/**********************************************************************
  ߎs}N߂lݒ
  $Id: op_exec.h,v 1.2 2002/02/18 13:57:02 tane Exp $
**********************************************************************/
#define	update_cr(r) {if((int)(r)==0){(mres->FLGR.cr[0] |= 0x20000000);}\
                      else{(mres->FLGR.cr[0] &=~0x20000000);};\
                      if((int)(r) >0){(mres->FLGR.cr[0] |= 0x40000000);}\
		      else{(mres->FLGR.cr[0] &=~0x40000000);};\
                      if((int)(r) <0){(mres->FLGR.cr[0] |= 0x80000000);}\
		      else{(mres->FLGR.cr[0] &=~0x80000000);};\
                      mres->FLGR.cr[0] &=0xefffffff ;\
                      mres->FLGR.cr[0] |=((mres->FLGR.xer & 0x80000000)>>3);\
                     };
#define	update_crf(fa,fb,cr) {if(fa==fb){(mres->FLGR.cr[cr] |= 0x20000000);}\
                              else{(mres->FLGR.cr[cr] &=~0x20000000);};\
	                      if(fa> fb){(mres->FLGR.cr[cr] |= 0x40000000);}\
			      else{(mres->FLGR.cr[cr] &=~0x40000000);};\
	                      if(fa< fb){(mres->FLGR.cr[cr] |= 0x80000000);}\
			      else{(mres->FLGR.cr[cr] &=~0x80000000);};\
	                      if(isnan(fa)!=0||isnan(fb)!=0){(mres->FLGR.cr[cr] |= 0x10000000);}\
			      else{(mres->FLGR.cr[cr] &=~0x10000000);};\
			     };


#define OPFETCH_FLAG            0x40000000
#define PC_BOUNDARY_ERROR       0x00000001
#define MEM_AREA_OVER           0x00000002
#define UNKNOWN_INSTRUCTION     0x00000003
#define DIVIDED_BY_ZERO         0x00000004
#define INVALID_BO              0x00000005
#define INSTFORM_IS_INVALID     0x00000006
#define UNKNOWN_SYSCALL_NO      0x00000007
#define NOT_IMPLEMENTED_OP      0x00000008
#define SYSCALLED_EXIT          0x00000009
#define SYSCALLED_FORK          0x00000010
#define SYSCALLED_EXECVE        0x00000011
#define EXCEPTION_SYSCALL       0x00000020
#define EXCEPTION_DEC           0x00000021
#define EXCEPTION_SE            0x00000022
#define EXCEPTION_EE            0x00000023
#define NON_PHYMEM              0x00000064

#define EXEC_INST               0x00000001
#define EXEC_DIS                0x00000002

#define DO_EXEC_INST(md)         ((md&EXEC_INST)!=0)
#define DO_EXEC_DIS(md)          ((md&EXEC_DIS )!=0)

struct OP_TBL_STRUCT{
  int           (*func)() ;
  long long int count ;
  unsigned char *name ;
} ;

#define TBL_SIZE_bit00to05     64
#define TBL_SIZE_bit21to30   1024
#define TBL_SIZE_bit27to30     16

struct OP_TBL_STRUCT op_func_tbl[TBL_SIZE_bit00to05];
struct OP_TBL_STRUCT op_13_subfunc_tbl[TBL_SIZE_bit21to30];
struct OP_TBL_STRUCT op_1f_subfunc_tbl[TBL_SIZE_bit21to30];
struct OP_TBL_STRUCT op_3b_subfunc_tbl[TBL_SIZE_bit27to30];
struct OP_TBL_STRUCT op_3f_subfunc0_tbl[TBL_SIZE_bit21to30];
struct OP_TBL_STRUCT op_3f_subfunc1_tbl[TBL_SIZE_bit27to30];

int init_op_func_tbl() ;

int op_exec( struct MACHINE_RESOURCE *mres , int mode ) ; /* top of instruction decode */

int op_scemu( struct MACHINE_RESOURCE *mres ) ; /* sc emulation */

int op_unknown_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* unknown */

int op_03_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* twi */
int op_07_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mulli */
int op_08_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfic */
int op_0a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* cmpli */
int op_0b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* cmpi */
int op_0c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addic */
int op_0d_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addic. */
int op_0e_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addi */
int op_0f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addis */

int op_10_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* bc,bca,bcl,bcla */
int op_11_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sc */
int op_12_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* b,ba,bl,bla */
int op_13_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* call op_13_subfunc */
int op_14_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* rlwimi,rlwimi. */
int op_15_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* rlwinmi,rlwinmi. */
int op_17_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* rlwnm,rlwnm. */
int op_18_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* ori */
int op_19_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* oris */
int op_1a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* xori */
int op_1b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* xoris */
int op_1c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* andi. */
int op_1d_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* andis. */
int op_1f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* call op_1f_subfunc */

int op_20_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwz */
int op_21_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwzu */
int op_22_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lbz */
int op_23_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lbzu */
int op_24_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stw */
int op_25_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stwu */
int op_26_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stb */
int op_27_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stbu */
int op_28_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhz */
int op_29_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhzu */
int op_2a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lha */
int op_2b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhau */
int op_2c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sth */
int op_2d_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stbu */
int op_2e_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lmw */
int op_2f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stmw */

int op_30_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfs */
int op_31_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfsu */
int op_32_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfd */
int op_33_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfdu */
int op_34_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfs */
int op_35_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfsu */
int op_36_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfd */
int op_37_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfdu */
int op_3b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* 3b */
int op_3f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* 3f */

/**********************************************************************/
int op_13_000_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* mcrf */
int op_13_010_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* bclrx */
int op_13_021_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crnor */
int op_13_032_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* rfi */
int op_13_081_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crandc */
int op_13_096_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* isync */
int op_13_0c1_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crxor */
int op_13_0e1_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crnand */
int op_13_101_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crand */
int op_13_121_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* creqv */
int op_13_1a1_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* crorc */
int op_13_1c1_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* cror */
int op_13_210_func( struct MACHINE_RESOURCE *mres, int mode ) ; /* bcctrx */

/**********************************************************************/
int op_1f_000_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* cmp */
int op_1f_004_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* tw */
int op_1f_008_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfcx */
int op_1f_00a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addcx */
int op_1f_00b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mulhwux */
int op_1f_013_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mfcr */
int op_1f_014_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwarx */
int op_1f_017_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwzx */
int op_1f_018_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* slwx */
int op_1f_01a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* cntlzw */
int op_1f_01c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* andx */
int op_1f_020_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* cmp */
int op_1f_028_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfx */
int op_1f_036_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbst 肠NOP */
int op_1f_037_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwzux */
int op_1f_03c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* andcx */
int op_1f_04b_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mulhwx */
int op_1f_052_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtsrd */
int op_1f_053_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mfmsr */
int op_1f_056_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbf 肠NOP */
int op_1f_057_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lbzx */
int op_1f_068_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* negx */
int op_1f_072_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtsrdin */
int op_1f_077_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lbzux */
int op_1f_07c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* norx */
int op_1f_088_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfex */
int op_1f_08a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addex */
int op_1f_090_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtcrf */
int op_1f_092_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtmsr */
int op_1f_096_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stwcx. */
int op_1f_097_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stwx */
int op_1f_0b7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stwux */
int op_1f_0c8_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfzex */
int op_1f_0ca_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addzex */
int op_1f_0d2_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtsr */
int op_1f_0d7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stbx */
int op_1f_0e8_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfmex */
int op_1f_0ea_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addmex */
int op_1f_0eb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mullwx */
int op_1f_0f2_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtsrin */
int op_1f_0f6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbtst 肠NOP */
int op_1f_0f7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stbux */
int op_1f_10a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addx */
int op_1f_116_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbt */
int op_1f_117_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhzx */
int op_1f_11c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* eqvx */
int op_1f_132_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* tlbie */
int op_1f_136_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* eciwx */
int op_1f_137_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhzux */
int op_1f_13c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* xorx */
int op_1f_153_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mfspr */
int op_1f_157_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhax */
int op_1f_172_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* tlbia */
int op_1f_173_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mftb */
int op_1f_177_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhaux */
int op_1f_197_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sthx */
int op_1f_19c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* orcx */
int op_1f_1b6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* ecowx */
int op_1f_1b7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sthux */
int op_1f_1bc_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* orx */
int op_1f_1cb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* divwux */
int op_1f_1d3_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mtspr */
int op_1f_1d6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbi */
int op_1f_1dc_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* nandx */
int op_1f_1eb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* divwx */
int op_1f_200_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mcrxr */
int op_1f_208_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfcx */
int op_1f_20a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addcx */
int op_1f_215_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lswx */
int op_1f_216_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lwbrx */
int op_1f_217_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfsx */
int op_1f_218_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* srwx */
int op_1f_228_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfx */
int op_1f_236_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* tlbsync */
int op_1f_237_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfsux */
int op_1f_253_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mfsr */
int op_1f_255_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lswi */
int op_1f_256_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sync Ƃ肠NOP */
int op_1f_257_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfdx */
int op_1f_268_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* negx */
int op_1f_277_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lfdux */
int op_1f_288_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfex */
int op_1f_28a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addex */
int op_1f_293_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mfsrin */
int op_1f_295_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stswx */
int op_1f_296_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stwbrx */
int op_1f_297_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfsx */
int op_1f_2b7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfsux */
int op_1f_2c8_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfzex */
int op_1f_2ca_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addzex */
int op_1f_2d5_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stswi */
int op_1f_2d7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfdx */
int op_1f_2e8_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* subfmex */
int op_1f_2ea_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addmex */
int op_1f_2eb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* mullwx */
int op_1f_2f6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcba */
int op_1f_2f7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfdux */
int op_1f_30a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* addx */
int op_1f_316_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* lhbrx */
int op_1f_318_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* srawx */
int op_1f_338_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* srawix */
int op_1f_356_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* eieio */
int op_1f_396_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* sthbrx */
int op_1f_39a_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* extshx */
int op_1f_3ba_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* extsbx */
int op_1f_3cb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* divwux */
int op_1f_3d6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* icbi */
int op_1f_3d7_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* stfiwx */
int op_1f_3eb_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* divwx */
int op_1f_3f6_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* dcbz */

/**********************************************************************/
int op_3b_002_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fdivsx */
int op_3b_004_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fsubsx */
int op_3b_005_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* faddsx */
int op_3b_008_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fresx */
int op_3b_009_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmulsx */
int op_3b_00c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmsubsx */
int op_3b_00d_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmaddsx */
int op_3b_00e_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnmsubsx */
int op_3b_00f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnmaddsx */

/**********************************************************************/
int op_3f_000_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fcmpu */
int op_3f_00c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* frspx */
int op_3f_00f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fctiwzx */
int op_3f_020_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fcmpo */
int op_3f_028_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnegx */
int op_3f_048_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmrx */
int op_3f_088_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnabsx */
int op_3f_108_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fabsx */
int op_3f_x12_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fdivx */
int op_3f_x14_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fsubx */
int op_3f_x15_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* faddx */
int op_3f_x19_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmulx */
int op_3f_x1c_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmsubx */
int op_3f_x1d_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fmaddx */
int op_3f_x1e_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnmsubx */
int op_3f_x1f_func( struct MACHINE_RESOURCE *mres , int mode ) ; /* fnmaddx */

void dis_print_r(FILE *fp, int r1) ;
void dis_print_rr(FILE *fp, int r1, int r2) ;
void dis_print_rrr(FILE *fp, int r1, int r2, int r3) ;
void dis_print_rrd(FILE *fp, int r1, int r2, int d) ;
void dis_print_rri(FILE *fp, int r1, int r2, int i) ;
void dis_print_crri(FILE *fp, int r1, int r2, int d) ;
void dis_print_rrddd(FILE *fp, int r1, int r2, int d1, int d2, int d3) ;
void dis_print_fr(FILE *fp, int r1) ;
void dis_print_frfr(FILE *fp, int r1, int r2) ;
void dis_print_frfrfr(FILE *fp, int r1, int r2, int r3) ;
void dis_print_frfrfrfr(FILE *fp, int r1, int r2, int r3, int r4) ;
void dis_print_crbcrbcrb(FILE *fp, int r1, int r2, int r3) ;

