/**********************************************************************
  long long int printf
  $Id: printll.c,v 1.1 2002/02/18 13:57:02 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int printll(FILE *fp, long long int val)
{
  int i,j ;
  unsigned char str[64] ;

  for( i=0 ; i<64 ; i++ ){
    str[i]= '0' + (val%10) ;
    val /= 10 ;
    if( val==0 ) break ;
  }
  for( j=i ; j>-1 ; j-- ){
    fputc(str[j],fp) ;
  }
  return(0) ;
}
      


